//*****************************************************************************************************
//  1. t@C
//		ConvAsuDlg.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ASUf[^t@Cǂݍ݃_CAONX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		
//----------------------------------------------------------------------------------------------------
//  4. 
//		2016.02.01 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "ConvAsuDlg.h"
#include "General.h"


// CConvAsuDlg _CAO

IMPLEMENT_DYNAMIC(CConvAsuDlg, CDialog)

CConvAsuDlg::CConvAsuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvAsuDlg::IDD, pParent)
{

}

CConvAsuDlg::~CConvAsuDlg()
{
}

void CConvAsuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_DATA_FILE, m_cEditDataFile);
	DDX_Control(pDX, IDC_EDIT_START_TIME, m_cEditStartTime);
	DDX_Control(pDX, IDC_EDIT_END_TIME, m_cEditEndTime);
	DDX_Control(pDX, IDC_EDIT_MEAS_TIME, m_cEditMeasTime);
	DDX_Control(pDX, IDC_EDIT_DOWNLINK, m_cEditDownlink);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_cEditComment);
	DDX_Control(pDX, IDC_EDIT_SAMPLE_RATE, m_cEditSampleRate);
	DDX_Control(pDX, IDC_BUTTON_REF, m_cButtonRef);
	DDX_Control(pDX, IDC_BUTTON_CONV, m_cButtonConv);
	DDX_Control(pDX, IDCANCEL, m_cButtonCancel);
}


BEGIN_MESSAGE_MAP(CConvAsuDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_REF, &CConvAsuDlg::OnBnClickedButtonRef)
	ON_BN_CLICKED(IDC_BUTTON_CONV, &CConvAsuDlg::OnBnClickedButtonConv)
END_MESSAGE_MAP()

// c[`bv\f[^
static const SToolTipData s_aToolTip[] = {
	{IDC_BUTTON_REF, "ASUf[^t@CI邽߂̃_CAOJ܂B"},
	{IDC_BUTTON_CONV, "ݒ肳ꂽeŁAASUf[^t@C̓ǂݍ݂s܂B"},
	{IDCANCEL, "̃_CAO܂B"},
	{0, NULL}
};

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::ShowDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ASUf[^t@Cǂݍ݃_CAO\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDocument	*pDoc		[I] hLgNX|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::ShowDialog(CDocument *pDoc)
{
	m_pDoc = pDoc;

	DoModal();
}

// CConvAsuDlg bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CConvAsuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// c[`bv\ݒ
	CGeneral::SetToolTip(m_tooltip, s_aToolTip, this);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::OnBnClickedButtonRef
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ASUf[^t@C̎Qƃ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::OnBnClickedButtonRef()
{
	CFileDialog dlg(TRUE, "csv", NULL, OFN_HIDEREADONLY, _T("ASUf[^t@C (*.csv)|*.csv||"));
	if (dlg.DoModal() == IDOK) {
		CString sDataFile = dlg.GetPathName();
		m_cEditDataFile = sDataFile;

		if (!CheckDataFile(sDataFile))
			m_cEditDataFile = "";
	}

	// ϊ{^L
	EnableConvButton();
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::CheckDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ItH_̃`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pDataFile		[I] It@C
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSE:G[
//*****************************************************************************************************
BOOL CConvAsuDlg::CheckDataFile(LPCTSTR pDataFile)
{
	double fSampleRate;
	CDataDateTime oStartTime, oEndTime;
	int nMeasTime;

	// ASUf[^t@C`FbN
	if (m_oAsuFile.CheckDataFile(pDataFile, fSampleRate, oStartTime, oEndTime, nMeasTime)) {
		// TvO[g\
		m_cEditSampleRate.Format("%g", fSampleRate);

		// Jn\
		m_cEditStartTime = oStartTime.GetStr();

		// I\
		m_cEditEndTime = oEndTime.GetStr();

		// vԕ\
		CString sMeasTime;
		sMeasTime.Format("%dhours  %02dmin  %02dsec", nMeasTime / 3600, nMeasTime / 60 % 60, nMeasTime % 60);
		m_cEditMeasTime = sMeasTime;

		// _EN\
		// Jn̓tftHgŕ\
//		m_cEditDownlink = oStartTime.GetStrYMDHMS();
		m_cEditDownlink = oStartTime.GetStrYMD();

		return TRUE;
	} else
		return FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::OnBnClickedButtonConv
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@Cǂݍ݃{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::OnBnClickedButtonConv()
{
	// ϊς݃t@C݃`FbN
	if (m_oAsuFile.m_bOverWrite) {
		if (AfxMessageBox("̕ϊf[^͊ɑ݂܂B̂܂ܓǂݍݏsƁCf[^㏑܂B\nǂݍݏp܂H",MB_ICONQUESTION|MB_YESNO) == IDNO)
			return;
	}

	// smF
	if (AfxMessageBox("ǂݍݏs܂H", MB_YESNO) != IDYES)
		return;

	// ̓f[^Zbg
	m_oAsuFile.m_sDownlink = m_cEditDownlink;
	m_oAsuFile.m_sComment = m_cEditComment;

	// {^𖳌ɂ
	KeyOff();

	// oCiϊ
	BOOL nResult = m_oAsuFile.ConvDataFile();

	// r[XV
	m_pDoc->UpdateAllViews(NULL);

	if (nResult) {
		// ϊIbZ[W\
		AfxMessageBox("ǂݍݏI܂", MB_ICONINFORMATION | MB_OK);
	} else {
		// ϊ~bZ[W\
		AfxMessageBox("ǂݍݏ𒆎~܂", MB_ICONINFORMATION | MB_OK);
	}

	// {^Lɂ
	KeyOn();
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::OnOK
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OK{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::OnOK()
{
	// ȂiEnterL[ŕȂ悤ɂj
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::EnableConvButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊ{^̗L^ݒ肷
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::EnableConvButton()
{
	BOOL bEnable = TRUE;

	// f[^tH_̓`FbN
	if (m_cEditDataFile.IsEmpty())
		bEnable = FALSE;

	// _EN̓`FbN
	if (m_cEditDownlink.IsEmpty())
		bEnable = FALSE;

	// ϊ{^L^ɐݒ
	m_cButtonConv.EnableWindow(bEnable);
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::KeyOff
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ƀ{^GRAYɂ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::KeyOff(void)
{
	m_cButtonConv.EnableWindow(FALSE);
	m_cButtonCancel.EnableWindow(FALSE);
	m_cButtonRef.EnableWindow(FALSE);
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::KeyOn
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^GRAY
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CConvAsuDlg::KeyOn(void)
{
	EnableConvButton();
	m_cButtonCancel.EnableWindow(TRUE);
	m_cButtonRef.EnableWindow(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CConvAsuDlg::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] MSG\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	eNX̕Ԓl̂܂ܕԂ
//*****************************************************************************************************
BOOL CConvAsuDlg::PreTranslateMessage(MSG* pMsg)
{
	// c[`bv\邽߂̏
	switch(pMsg->message){
	case WM_LBUTTONDOWN:            
	case WM_LBUTTONUP:              
	case WM_MOUSEMOVE:
		if (m_tooltip.m_hWnd)
			m_tooltip.RelayEvent(pMsg);
		break;
	}

	return CDialog::PreTranslateMessage(pMsg);
}
